#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266HTTPUpdateServer.h>
#include <NTPClient.h>
#include <WiFiUdp.h>
#include <WebSocketsServer.h>
#include <EEPROM.h>
int addr = 100;
#define DISABLE_CODE_FOR_RECEIVER
#include "PinDefinitionsAndMore.h"  // GPIO14 к R6 (IR)
#include <IRremote.hpp>
#include <OneWire.h>
#include <DallasTemperature.h>
#include <NonBlockingDallas.h>
#define ONE_WIRE_BUS 4      //GPIO4 к DS18B20
#define TIME_INTERVAL 5000  //период чтения DS18B20 в миллисекндах 
#define ARRAY_SIZE 12 //колличество записей показаний DS18B20
String temperature_base[ARRAY_SIZE];
String temperature_base_itog = "";
String temperature_base_in = "";
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature dallasTemp(&oneWire);
NonBlockingDallas sensorDs18b20(&dallasTemp);  //Create a new instance of the NonBlockingDallas class
float t1 = 0;
int t1_int = 0;
String inString = "";
#define RELE 12  //GPIO12 к R7 (РЕЛЕ)
const uint16_t rawData26[131] = { 8980, 4420, 580, 570, 530, 570, 580, 1670, 530, 570, 580, 1620, 580, 570, 530, 570, 580, 520, 580, 1670, 580, 1670, 530, 520, 630, 1670, 530, 520, 580, 1670, 580, 1670, 580, 1670, 530, 1670, 580, 570, 530, 570, 530, 1670, 580, 1670, 580, 520, 580, 570, 530, 1670, 580, 1620, 630, 520, 580, 520, 580, 570, 530, 570, 580, 1670, 530, 570, 580, 1670, 530, 520, 630, 520, 580, 1670, 530, 570, 580, 1620, 580, 570, 580, 520, 580, 570, 530, 570, 580, 520, 580, 520, 580, 520, 580, 570, 580, 520, 580, 520, 580, 570, 580, 520, 580, 570, 530, 570, 580, 520, 580, 520, 580, 520, 580, 570, 580, 520, 580, 570, 530, 570, 580, 520, 580, 520, 580, 520, 630, 520, 580, 570, 530, 570, 530 };  // код для кондиционера Raw-Data=0x14 64 bits LSB first 
#include "index.h"
#include "update.h"

IPAddress ip(192, 168, 1, 25); // IP
IPAddress gateway(192, 168, 1, 1); // ШЛЮЗ
IPAddress subnet(255, 255, 255, 0); // МАСКА
IPAddress dns(8, 8, 8, 8); // DNS

WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "pool.ntp.org");
unsigned long epochTime = 0;
unsigned long previousMillis_T = 0;
const long interval_T = 1000; //интервал в миллисекундах обновления показаний времени
uint16_t t_t = 0;

#ifndef STASSID
#define STASSID "your-ssid" //ssid 
#define STAPSK "your-password" //пароль
#endif

const char* ssid = STASSID;
const char* password = STAPSK;

ESP8266WebServer httpServer(80);
WebSocketsServer webSocket = WebSocketsServer(8080);
ESP8266HTTPUpdateServer httpUpdater;
String bp = "";
void handleIntervalElapsed(float temperature, bool valid, int deviceIndex) {
  t1 = temperature;
}
char m[4];
char s[4];
uint8_t hour, minute, second, day, month, weekday;
uint16_t year;
uint8_t monthDays[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
void my_clock() {
  second++; 
  if (second > 59) {
    second = 0;
    minute++;
    if (minute > 59) {
      minute = 0;
      hour++;
      if (hour > 23) {
        hour = 0;
        day++;
        if (month > 1)
          if (day > monthDays[month - 1]) {
            day = 1;
            month++;
            if (month > 12) {
              year++;
              month = 1;
            }
          }
      }
    }
  }
}

int flr = 0;
void webSocketEvent(uint8_t num, WStype_t type, uint8_t* payload, size_t length) {

  switch (type) {
    case WStype_DISCONNECTED:
      //USE_SERIAL.printf("[%u] Disconnected!\n", num);
      break;
    case WStype_CONNECTED:
      {
        IPAddress ip = webSocket.remoteIP(num);
        //USE_SERIAL.printf("[%u] Connected from %d.%d.%d.%d url: %s\n", num, ip[0], ip[1], ip[2], ip[3], payload);
      }
      break;
    case WStype_TEXT:
      {
        //Serial.printf("[%u] get Text: %s\n", num, payload);
        if (payload[0] == 'p') {
          uint8_t tk = (uint8_t)strtol((const char*)&payload[1], NULL, 10);
          //on
          if (tk == 26) {
            digitalWrite(RELE, HIGH);
            flr = 1;
          }

          //off
          if (tk == 30) {
            digitalWrite(RELE, LOW);
            EEPROM.write(addr, 30);
            EEPROM.commit();
            bp = "c";
          }
        }
      }
      break;
  }
  delay(1);
}

void handleRoot() {
  httpServer.send(200, "text/html", INDEX_HTML);
}

void updateArray(String newVal) {
  for (byte i = 0; i < ARRAY_SIZE - 1; i++) {
    temperature_base[i] = temperature_base[i + 1];
  }
  temperature_base[ARRAY_SIZE - 1] = newVal;
}
void printArray() { 
  temperature_base_itog = "";
  for (byte i = 0; i < ARRAY_SIZE; i++) {
    if (temperature_base[i] != "") {
      temperature_base_itog += ",";
    }
    temperature_base_itog += temperature_base[i];
  }
  temperature_base_itog.remove(0, 1);
}

void setup(void) {
  pinMode(RELE, OUTPUT);
  digitalWrite(RELE, LOW);
  EEPROM.begin(512);
  Serial.begin(115200);
  Serial.println();
  Serial.println("Booting Sketch...");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  WiFi.config(ip, gateway, subnet, dns);

  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    WiFi.begin(ssid, password);
    Serial.println("WiFi failed, retrying.");
  }

  Serial.print("Station IP Address: ");
  Serial.println(WiFi.localIP());
  WiFi.setAutoReconnect(true);
  WiFi.persistent(true);
  IrSender.begin();
  webSocket.begin();
  webSocket.onEvent(webSocketEvent);

  httpServer.on("/", handleRoot);

  httpServer.on("/update.html", HTTP_GET, [&]() {
    httpServer.send_P(200, "text/html", UPLOAD);
  });

  httpUpdater.setup(&httpServer);
  httpServer.begin();
  timeClient.begin();
  timeClient.setTimeOffset(10800);

  sensorDs18b20.begin(NonBlockingDallas::resolution_12, NonBlockingDallas::unit_C, TIME_INTERVAL);
  sensorDs18b20.onIntervalElapsed(handleIntervalElapsed);
  sensorDs18b20.requestTemperature();
  delay(1000);
  sensorDs18b20.update();
  sensorDs18b20.update();
  Serial.println(t1);

  t1_int = int(t1 + 0.5);
  temperature_base_in = "";
  temperature_base_in += "[[";
  temperature_base_in += hour;
  temperature_base_in += ",";
  temperature_base_in += minute;
  temperature_base_in += ",";
  temperature_base_in += 0;
  temperature_base_in += "], ";
  temperature_base_in += t1_int;
  temperature_base_in += "]";

  byte valueM;
  valueM = EEPROM.read(addr);

  if (valueM == 26) {
    digitalWrite(RELE, HIGH);
    delay(5000);
    IrSender.sendRaw(rawData26, sizeof(rawData26) / sizeof(rawData26[0]), NEC_KHZ);
    bp = "b";
  }

  if (valueM == 30) {
    bp = "c";
  }

  timeClient.update();
  delay(1000);
  hour = timeClient.getHours();
  minute = timeClient.getMinutes();
  second = timeClient.getSeconds();
  Serial.println(timeClient.getFormattedTime());
}

int t_m = 0;

void loop(void) {
  httpServer.handleClient();
  webSocket.loop();
  sensorDs18b20.update();

  unsigned long currentMillis_T = millis();
  if (currentMillis_T - previousMillis_T >= interval_T) {
    previousMillis_T = currentMillis_T;

    my_clock();
    sprintf(s, "%02d", second);
    sprintf(m, "%02d", minute);
    t1_int = int(t1 + 0.5);

    if (t_t == 0) {
      temperature_base_in = "";
      temperature_base_in += "[[";
      temperature_base_in += hour;
      temperature_base_in += ",";
      temperature_base_in += minute;
      temperature_base_in += ",";
      temperature_base_in += 0;
      temperature_base_in += "], ";
      temperature_base_in += t1_int;
      temperature_base_in += "]";
      updateArray(temperature_base_in);
      printArray();
      Serial.println(temperature_base_in);
      Serial.println(temperature_base_itog);
    }

    if (flr == 1) {
      Serial.println("0n-0");
      if (t_m < 5) {
        Serial.println(t_m);
        t_m++;
      } else {
        IrSender.sendRaw(rawData26, sizeof(rawData26) / sizeof(rawData26[0]), NEC_KHZ);
        bp = "b";
        EEPROM.write(addr, 26);
        EEPROM.commit();
        Serial.println("0n-1");
        t_m = 0;
        flr = 0;
      }
    }

    inString = "";
    inString += "A";
    inString += hour;
    inString += ":";
    inString += m;
    inString += ":";
    inString += s;
    inString += ";";
    inString += t1_int;
    inString += ";";
    inString += bp;
    inString += ";";
    inString += temperature_base_itog;
    inString += "C";
    t_t++;
    webSocket.broadcastTXT(inString);

    if (t_t > 300) {
      t_t = 0;
    }
  }
}
